
' Hardware:
' Start des Timers durch Reset
' Timer-Takt durch 50Hz-Streufeld an PB2
' Schaltausgang an PB4
' Anzeige Sekundentakt per LED an PB3 oder Buzzer an PB0
'
'----------------------------------------------------------



$regfile = "attiny13.dat"
$crystal = 1200000

$hwstack = 8
$swstack = 8
$framesize = 8
'Baud = 9600


Portb = &B00000011
Ddrb = &B00011001
Acsr.acd = 1                                                ' Analog-Komparator ausschalten


' Timer zu Fuss konfigurieren:

Tccr0a = 0                                                  ' Betrieb als Zaehler bis 255; einfach nur berlauf
Tccr0b = &B00000110                                         ' externer Takt an TO; falling edge
Timsk0 = &B00000010                                         ' Interruptquelle:  Counter0 overflow

Sreg.7 = 1                                                  ' Interrupts global freigeben

On Timer0 Ontimer0                                          ' Interrupt-Routine fr Timer0-Overflow


Dim S As Long



Do

    If S = 86400 Then                                       ' Zhler auf Null setzen; 24 h sind um
        S = 0
    End If

    If S > 10 And S < 3600 Then                             ' nach 10 Sekunden fr 1 Stunde Schaltausgang ein
        Portb.4 = 1
    Else                                                    ' Rest der Zeit Schaltausgang aus
        Portb.4 = 0
    End If

Loop

End



Ontimer0:
    Tcnt0 = 206
    Portb.3 = 1                                             ' Sekunden-LED ein
    Waitms 50
    Portb.3 = 0                                             ' Sekunden-LED aus
'    Sound Portb.0 , 100 , 100                              ' alternativ: Soundausgabe an PB0
    Incr S

Return